vRPCbus = {}
Tunnel.bindInterface("vrp_bus",vRPCbus)
Proxy.addInterface("vrp_bus",vRPCbus)
vRP = Proxy.getInterface("vRP")
vRPSbus = Tunnel.getInterface("vrp_bus","vrp_bus")

busSpawnLocs = nil
busStopsLocs = nil
theBlips = {}
busStopsBlip = nil
theBus = nil
hasBusRouteStarted = false
busCheckpoint = 0
atBusStop = false
finishBusRoute = {}
finishBlip = nil
busBlip = nil
busStopsBlip2 = nil
local cfg = {
    blippos = vec3(463.39947509766,-629.96600341797,28.474479675293)
}

function vRPCbus.busPopulateData(busSpawns, busLocs, finishTrash)
	busSpawnLocs = busSpawns
	busStopsLocs = busLocs
	finishBusRoute = finishTrash
end

function vRPCbus.deleteTheBus()
	if(DoesEntityExist(theBus))then
		Citizen.InvokeNative(0xEA386986E786A54F, Citizen.PointerValueIntInitialized(theBus))
		theBus = nil
	end
end

function vRPCbus.spawnTheBus()
	if(theBus == nil)then
		coords = GetEntityCoords(GetPlayerPed(-1), true)
		vehicle = GetHashKey("bus")
		RequestModel(vehicle)
		while not HasModelLoaded(vehicle) do
			Citizen.Wait(0)
		end
		theBus = CreateVehicle(vehicle, coords.x, coords.y, coords.z+0.5, 213.70028686523, true, false)
		SetVehicleOnGroundProperly(theBus)
		SetEntityInvincible(theBus, false)
		SetPedIntoVehicle(GetPlayerPed(-1), theBus, -1)
		Citizen.InvokeNative(0xAD738C3085FE7E11, theBus, true, true)
		SetVehicleHasBeenOwnedByPlayer(theBus, true)
		SetModelAsNoLongerNeeded(vehicle)
	end
end

function vRPCbus.nextBusStop()
	busCheckpoint = busCheckpoint + 1
	if(busStopsLocs[busCheckpoint][4] == true)then
		blipColor = 1
	else
		blipColor = 1
	end
	if(busStopsBlip == nil) or (DoesBlipExist(busStopsBlip))then
		if(DoesBlipExist(busStopsBlip))then
			RemoveBlip(busStopsBlip)
		end
		busStopsBlip = AddBlipForCoord(busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3])
		SetBlipRoute(busStopsBlip, true)
		SetBlipSprite(busStopsBlip, 8)
		SetBlipColour(busStopsBlip, blipColor)
		SetBlipRouteColour(busStopsBlip, 1)
	end
	if(busCheckpoint+1 <= #busStopsLocs)then
		if(busStopsBlip2 == nil) or (DoesBlipExist(busStopsBlip2))then
			if(DoesBlipExist(busStopsBlip2))then
				RemoveBlip(busStopsBlip2)
			end
			busStopsBlip2 = AddBlipForCoord(busStopsLocs[busCheckpoint+1][1], busStopsLocs[busCheckpoint+1][2], busStopsLocs[busCheckpoint+1][3])
			SetBlipSprite(busStopsBlip2, 8)
			SetBlipColour(busStopsBlip2, 29)
			SetBlipRouteColour(busStopsBlip, 29)
		end
	end
end

function vRPCbus.stopBusRoute()
	hasBusRouteStarted = false
	vRP.notify({"Ai anulat tura de Sofer Autobuz!"})
	busCheckpoint = 0
	if(DoesBlipExist(busStopsBlip))then
		RemoveBlip(busStopsBlip)
		busStopsBlip = nil
	end
	if(DoesBlipExist(busStopsBlip2))then
		RemoveBlip(busStopsBlip2)
		busStopsBlip2 = nil
	end
	if(DoesBlipExist(busBlip))then
		RemoveBlip(busBlip)
		busBlip = nil
	end
	if(DoesBlipExist(finishBlip))then
		RemoveBlip(finishBlip)
		finishBlip = nil
	end
	vRPSbus.stopBusRoute({})
	atBusStop = false
end

function vRPCbus.finishBusRoute(route)
	hasBusRouteStarted = false
	busCheckpoint = 0
	if(DoesBlipExist(busStopsBlip))then
		RemoveBlip(busStopsBlip)
		busStopsBlip = nil
	end
	if(DoesBlipExist(busStopsBlip2))then
		RemoveBlip(busStopsBlip2)
		busStopsBlip2 = nil
	end
	if(DoesBlipExist(busBlip))then
		RemoveBlip(busBlip)
		busBlip = nil
	end
	if(DoesBlipExist(finishBlip))then
		RemoveBlip(finishBlip)
		finishBlip = nil
	end
	atBusStop = false
	vRPCbus.deleteTheBus()
	vRPSbus.payBusDriver({route})
end

function vRPCbus.stopAtBusStop(isBusStop)
	if(isBusStop == false)then
		vRPCbus.nextBusStop()
	else
		if(atBusStop == false)then
			atBusStop = true
			vRP.notify({"Info: Asteapta la statie pana ce pasagerii au urcat!"})
			SetTimeout(8000, function()
				if(atBusStop)then
					atBusStop = false
					if(#busStopsLocs > busCheckpoint)then
						vRPCbus.nextBusStop()
						vRP.notify({"Pasagerii au urcat! Te poti duce la urmatoarea statie"})
						vRPSbus.payBusDriverAtStop({})
					else
						if(DoesBlipExist(busStopsBlip))then
							RemoveBlip(busStopsBlip)
							busStopsBlip = nil
						end
						vRP.notify({"Ti-ai terminat tura! Intoarce-te inapoi la sediu pentru a lasa autobuzul!"})
					end
				else
					vRP.notify({"Trebuie sa astepti in checkpoint pentru a lasa pasagerii sa urce!"})
				end
			end)
		end
	end
end

RegisterCommand("cc", function(source)
	print("CC: "..busCheckpoint)
end)

Citizen.CreateThread(function()
	while true do
		Wait(0)
		local ped = _GPED
		local pos = _GCOORDS	
		if((not DoesEntityExist(theBus)) or (IsEntityDead(theBus))) and (hasBusRouteStarted)then
			vRPCbus.stopBusRoute()
			theBus = nil
		end
		if(atBusStop)then
			drawScreenTextz2(0.50, 0.80, 0.0, 0.0, 0.4, "~HUD_COLOUR_NET_PLAYER13~Bus Driver~n~~w~Asteapta la statie...", 255, 255, 255, 255, 1, fontId)
		end
		if(theBus ~= nil)then
			if(GetVehiclePedIsIn(ped, false) == theBus) and (GetPedInVehicleSeat(theBus, -1) == ped) then
				pos = GetEntityCoords(_GPED)
				if(hasBusRouteStarted == false)then
					hasBusRouteStarted = true
					for i, v in pairs(theBlips) do
						if(DoesBlipExist(v))then
							RemoveBlip(v)
							theBlips[i] = nil
						end
					end
					vRPCbus.nextBusStop()
					vRP.notify({"Info: Urmeaza ruta si asteapta la fiecare statie pentru a primii bani!"})
				end
				if(tonumber(#busStopsLocs) > tonumber(busCheckpoint))then
					if(#busStopsLocs >= busCheckpoint+1)then
						if(busStopsLocs[busCheckpoint+1][4] == true)then
							DrawMarker(1, busStopsLocs[busCheckpoint+1][1], busStopsLocs[busCheckpoint+1][2], busStopsLocs[busCheckpoint+1][3]-1.0, 0, 0, 0, 0, 0, 0, 2.0, 2.0, 200.0, 42, 166, 185, 180, 0, 0, 0, 0)
						else
							DrawMarker(1, busStopsLocs[busCheckpoint+1][1], busStopsLocs[busCheckpoint+1][2], busStopsLocs[busCheckpoint+1][3]-1.0, 0, 0, 0, 0, 0, 0, 2.0, 2.0, 200.0, 153, 51, 255, 150, 0, 0, 0, 0)
						end
					end
					if(busStopsLocs[busCheckpoint][4] == true)then
						DrawMarker(1, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3]-1.0, 0, 0, 0, 0, 0, 0, 5.0, 5.0, 200.0, 42, 166, 185, 180, 0, 0, 0, 0)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3], true) < 8.0)then
							if(atBusStop == false)then
								vRPCbus.stopAtBusStop(true)
							end
						else
							atBusStop = false
						end
					else
						DrawMarker(1, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3]-1.0, 0, 0, 0, 0, 0, 0, 5.0, 5.0, 200.0, 153, 51, 255, 150, 0, 0, 0, 0)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, busStopsLocs[busCheckpoint][1], busStopsLocs[busCheckpoint][2], busStopsLocs[busCheckpoint][3], true) < 8.0)then
							vRPCbus.stopAtBusStop(false)
						end
					end
				end
				if(busCheckpoint == #busStopsLocs)then
					if(finishBlip == nil)then
						finishBlip = AddBlipForCoord(finishBusRoute[1], finishBusRoute[2], finishBusRoute[3])
						SetBlipSprite(finishBlip, 8)
						SetBlipColour(finishBlip, 29)
						SetBlipAsShortRange(finishBlip, false)
					end
					drawtotal(finishBusRoute[1], finishBusRoute[2], finishBusRoute[3] - 1.65, "~s~ULTIMA STATIE", 2, 0.1, 0.1, 255, 255, 255, 255)
					DrawMarker(20, finishBusRoute[1], finishBusRoute[2], finishBusRoute[3]-0.2, 0, 0, 0, 0, 0, 0, 0.7, 0.7, 0.7, 42, 166, 185, 255, 0, 0, 0, 1)
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, finishBusRoute[1], finishBusRoute[2], finishBusRoute[3], true) < 5.0)then
						drawScreenTextz2(0.50, 0.86, 0.0, 0.0, 0.4, "Apasa [ ~HUD_COLOUR_NET_PLAYER13~E ~w~] pentru a termina cursa de ~HUD_COLOUR_NET_PLAYER13~Sofer Autobuz", 255, 255, 255, 255, 1, fontId)
						if(IsControlJustReleased(1, 51))then
							vRPCbus.finishBusRoute(busCheckpoint)
						end
					end
				end
				if(DoesBlipExist(busBlip))then
					RemoveBlip(busBlip)
					busBlip = nil
				end
			else
				drawScreenTextz2(0.50, 0.86, 0.0, 0.0, 0.4, "~HUD_COLOUR_NET_PLAYER13~Bus Driver~n~Intoarce-te la autobuz pentru a continua", 255, 255, 255, 255, 1, fontId)
				if(busBlip == nil)then
					busBlip = AddBlipForEntity(theBus)
					SetBlipSprite(busBlip, 8)
					SetBlipColour(busBlip, 29)
					SetBlipAsShortRange(busBlip, false)
				end
			end
		else
			if(hasBusRouteStarted)then
				vRPCbus.stopBusRoute()
			end
			if(busSpawnLocs ~= nil)then
				for i, v in pairs(busSpawnLocs) do
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, v[1], v[2], v[3], true) < 20.0)then
						drawtotal(v[1], v[2], v[3] - 1.65, "~HUD_COLOUR_NET_PLAYER13~AUTOBUZ", 2, 0.1, 0.1, 255, 255, 255, 255)
						DrawMarker(20, v[1], v[2], v[3]-0.2, 0, 0, 0, 0, 0, 0, 0.7, 0.7, 0.7, 47, 92, 115, 255, 0, 0, 0, 1)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, v[1], v[2], v[3], true) < 3.0)then
							drawScreenTextz2(0.50, 0.86, 0.0, 0.0, 0.4, "Apasa [ ~HUD_COLOUR_NET_PLAYER13~E ~w~]  ~w~pentru a spawna un ~HUD_COLOUR_NET_PLAYER13~Autobuz", 255, 255, 255, 255, 1, fontId)
							if(IsControlJustReleased(1, 51))then
								vRPCbus.spawnTheBus({})
							end
						end
					end
				end
			end
		end
	end
end)